package tech.nevets.vcardgen;

import spark.Request;
import spark.Response;
import spark.Route;

import javax.servlet.MultipartConfigElement;
import javax.servlet.http.Part;
import java.io.IOException;

public class EditRoute implements Route {
    @Override
    public Object handle(Request req, Response res) {
        req.attribute("org.eclipse.jetty.multipartConfig", new MultipartConfigElement("/temp"));
        Part cardFile;
        try {
            cardFile = req.raw().getPart("card");
        } catch (Exception e) {
            res.status(500);
            return "Error processing file: " + e.getMessage();
        }
        if (cardFile.getSize() > 1000000) {
            res.status(413);
            return "File too large";
        }
        if (!cardFile.getContentType().equalsIgnoreCase("image/png")) {
            res.status(415);
            return "Content is not of type image/png";
        }
        String cardData;
        try {
            cardData = Card.getDataFromVCard(cardFile.getInputStream());
        } catch (IOException e) {
            res.status(500);
            return "Error retrieving data from card" + e.getMessage();
        }
        if (cardData.equals("$null")) {
            res.status(422);
            return "Card does not contain required metadata";
        }
        res.type("application/json");
        res.status(200);
        return cardData;
    }
}
