package tech.nevets.vcardgen;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.google.gson.JsonSyntaxException;
import spark.Request;
import spark.Response;
import spark.Route;

import java.io.IOException;

public class GenerateRoute implements Route {
    private Card card;
    @Override
    public Object handle(Request req, Response res) {
        JsonObject data;
        try {
            data = new Gson().fromJson(req.body(), JsonObject.class);
        } catch (JsonSyntaxException e) {
            res.status(422);
            return "Not valid json: " + e.getMessage();
        }
        card = new Card(data);
        card.renderImage();

        res.type("image/png");
        res.header("Access-Control-Expose-Headers", "Id");
        res.header("Id", card.id);
        try {
            res.status(200);
            return card.toByteArray();
        } catch (IOException e) {
            res.status(500);
            return "Error getting image stream: " + e.getMessage();
        }
    }
}
